//
//  MTLUserInterfaceValidationUpdate.h
//  EnablerTest
//
//  Created by narita on 2013/01/28.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface MTLWindow : NSWindow
{
    BOOL autovalidates;
}

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action methods

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

@property (readwrite, nonatomic) BOOL autovalidates;

#pragma mark -
#pragma mark Utility methods

@end

// ===========================================================================================
#pragma mark -

@interface MTLPanel : NSPanel
{
    BOOL autovalidates;
}

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action methods

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

@property (readwrite, nonatomic) BOOL autovalidates;

#pragma mark -
#pragma mark Utility methods

@end

// ===========================================================================================
#pragma mark -

// このプロトコルに一致するオブジェクトは[window update]が呼ばれる時に、userInterfaceValidationUpdateが呼出される。
@protocol MTLUserInterfaceValidationUpdate
@optional
// optionalにする事で実装はそれぞれのクラス任せ。
// 実装されていれば、[NSView updateSubvewsUserInterfaceValidation]経由でMTLWindow/MTLPanelのupdateメソッドから呼出されます。
- (void) userInterfaceValidationUpdate;
@end

// ===========================================================================================
#pragma mark -

@interface NSView (MTLUserInterfaceValidationUpdate) <MTLUserInterfaceValidationUpdate>
// subviews全てを走査して、userInterfaceValidationUpdateを呼出す。
// MTLWindow/MTLPanelのupdateメソッドから呼ばれるので、通常は直接呼出す必要は有りません。
- (void) updateSubvewsUserInterfaceValidation;
@end
